//! `SeaORM` Entity, @generated by sea-orm-codegen 1.1.0

use sea_orm::entity::prelude::*;

#[derive(Clone, Debug, PartialEq, DeriveEntityModel, Eq)]
#[sea_orm(table_name = "AppInstallation")]
pub struct Model {
    #[sea_orm(primary_key, auto_increment = false)]
    pub id: Uuid,
    #[sea_orm(column_name = "createdAt")]
    pub created_at: DateTime,
    #[sea_orm(column_type = "JsonBinary")]
    pub settings: Json,
    #[sea_orm(column_type = "Text")]
    pub app_id: String,
    #[sea_orm(column_name = "ownerName", column_type = "Text")]
    pub owner_name: String,
    pub protected: bool,
    #[sea_orm(column_name = "initialDomain", column_type = "Text", nullable)]
    pub initial_domain: Option<String>,
    #[sea_orm(column_name = "currentChartVersion", column_type = "Text")]
    pub current_chart_version: String,
    pub paused: bool,
}

#[derive(Copy, Clone, Debug, EnumIter, DeriveRelation)]
pub enum Relation {
    #[sea_orm(has_many = "super::app_domain::Entity")]
    AppDomain,
    #[sea_orm(has_many = "super::snapshot::Entity")]
    Snapshot,
    #[sea_orm(
        belongs_to = "super::user::Entity",
        from = "Column::OwnerName",
        to = "super::user::Column::Username",
        on_update = "Cascade",
        on_delete = "Restrict"
    )]
    User,
}

impl Related<super::app_domain::Entity> for Entity {
    fn to() -> RelationDef {
        Relation::AppDomain.def()
    }
}

impl Related<super::snapshot::Entity> for Entity {
    fn to() -> RelationDef {
        Relation::Snapshot.def()
    }
}

impl Related<super::user::Entity> for Entity {
    fn to() -> RelationDef {
        Relation::User.def()
    }
}

impl ActiveModelBehavior for ActiveModel {}
